package fr.ippon.kata.numeral;

import java.util.Map.Entry;
import java.util.NavigableMap;
import java.util.TreeMap;

public class Numerals {
  private static final NavigableMap<Integer, String> CONVERSIONS = buildConversions();

  public static String toRoman(int arabic) {
    if (arabic == 0) {
      return "";
    }

    Entry<Integer, String> highestKnownConversion = CONVERSIONS.floorEntry(arabic);
    return highestKnownConversion.getValue() + toRoman(arabic - highestKnownConversion.getKey());
  }

  private static NavigableMap<Integer, String> buildConversions() {
    NavigableMap<Integer, String> conversions = new TreeMap<>();

    conversions.put(1, "I");
    conversions.put(4, "IV");
    conversions.put(5, "V");
    conversions.put(9, "IX");
    conversions.put(10, "X");

    return conversions;
  }
}
